/*
  Charlieplexing.h - Library for controlling the charliplexed led board
  from JimmiePRodgers.com
  Created by Alex Wenger, December 30, 2009.
  Modified by Matt Mets, May 28, 2010.
  Released into the public domain.
          2013-10-26 - update class library
*/

#ifndef ikkeiplexing_h
#define ikkeiplexing_h

#include <Arduino.h>

#define SINGLE_BUFFER 0
#define DOUBLE_BUFFER 1
#define FRAME 0x01
#define TENMS 0x02
#define SW_LEVEL 0
#define SW_PEDGE 1
#define SW_NEDGE 2

typedef struct {
  int x;
  int y;
} Coordinate;


enum {IKKEIPLEXING, TITCHAINO, TITCHAINO_UNI, ONBOARD, DOTSDUINO, DOTSDUINO2D, SQUARE8, DOMINODUINO};

class ikkeiplexing{
public:
    void Init(byte mode);
    void Init(byte assign, byte mode);
    void ShiftLeft();
    void ShiftRight();
    void Set(byte x, byte y, byte c);
    byte Get(byte x, byte y);
    void Flip(bool blocking = false);
    void Clear(int set=0);
    void Horizontal(int y, int set=0);
    void Vertical(int x, int set=0);
    byte GetSW(byte edge);
    byte GetPeriod(byte cbit);
 	void Vwrite(int x, byte data);
    void write(byte y, const uint16_t values[], byte size);
    void write90(byte y, const uint16_t values[], byte size);
    Coordinate GetAcceleration();
};

#endif
